/* Arduino HomeCtrl - Kit
   By TumRobot
*/

extern "C"{
	#include "DS1302.h"
        #include "XPORT_linker.h"
        #include "Timer.h"
}

/*
  LiquidCrystal Library - Hello World
 
 Demonstrates the use a 16x2 LCD display.  The LiquidCrystal
 library works with all LCD displays that are compatible with the
 Hitachi HD44780 driver. There are many of them out there, and you
 can usually tell them by the 16-pin interface.
 
 This sketch prints "Hello World!" to the LCD
 and shows the time.
 
  The circuit:
 * LCD RS pin to digital pin 6
 * LCD Enable pin to digital pin 7
 * LCD D4 pin to digital pin 5
 * LCD D5 pin to digital pin 4
 * LCD D6 pin to digital pin 3
 * LCD D7 pin to digital pin 2
 * LCD R/W pin to ground
 * 10K resistor:
 * ends to +5V and ground
 * wiper to LCD VO pin (pin 3)
 
 Library originally added 18 Apr 2008
 by David A. Mellis
 library modified 5 Jul 2009
 by Limor Fried (http://www.ladyada.net)
 example added 9 Jul 2009
 by Tom Igoe
 modified 22 Nov 2010
 by Tom Igoe
 
 This example code is in the public domain.

 http://www.arduino.cc/en/Tutorial/LiquidCrystal
 */

// include the library code:
#include <LiquidCrystal.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(6, 7, 5, 4, 3, 2);

/*
  Serial Event example
 
 When new serial data arrives, this sketch adds it to a String.
 When a newline is received, the loop prints the string and
 clears it.
 
 A good test for this is to try it with a GPS receiver
 that sends out NMEA 0183 sentences.
 
 Created 9 May 2011
 by Tom Igoe
 
 This example code is in the public domain.
 
 http://www.arduino.cc/en/Tutorial/SerialEvent
 
 */
 
int XportResetPin = 8;

String inputString = "";         // a string to hold incoming data
boolean stringComplete = false;  // whether the string is complete
word Timer_Display = 0;

void setup()
{      
            ds1302_struct rtc;
            
            pinMode(A0, OUTPUT);      // sets the A0 pin as output
            pinMode(A1, OUTPUT);      // sets the A1 pin as output
            pinMode(A2, OUTPUT);      // sets the A2 pin as output
            pinMode(A3, OUTPUT);      // sets the A3 pin as output
            pinMode(A4, OUTPUT);      // sets the A4 pin as output
            pinMode(A5, OUTPUT);      // sets the A5 pin as output
          
            inputString.reserve(100);
            
            Serial.begin(115200);
            Serial.println(F("HomeControl-Kit V1.00"));
          
            // Start by clearing the Write Protect bit
            // Otherwise the clock data cannot be written
            // The whole register is written,
            // but the WP-bit is the only bit in that register.
            DS1302_write (DS1302_ENABLE, 0);
          
            // Disable Trickle Charger.
            DS1302_write (DS1302_TRICKLE, 0x00);
          
            // Remove the next define,
            // after the right date and time are set.
            //Update_Date_Time( 27, 8, 2013, 2 , 21 , 05, 00 );
            
            lcd.begin(16, 2);
            
            /*================================================
            lcd.setCursor(0, 0); // top left
            lcd.setCursor(15, 0); // top right
            lcd.setCursor(0, 1); // bottom left
            lcd.setCursor(15, 1); // bottom right
            =================================================*/
            lcd.print("Arduino HomeCtrl");
            
            //Reset Xport For Read IP and MAC
            //================================================
            delay(1000);
            digitalWrite(XportResetPin, HIGH);
            delay(500);
            digitalWrite(XportResetPin, LOW);
}


void loop()
{
            ds1302_struct rtc;
            
            if( Timer_Display++ > 10000 ){
              
                      Timer_Display = 0;
                      // Read all clock data at once (burst mode).
                      
                      DS1302_clock_burst_read( (uint8_t *) &rtc);
  
                      lcd.setCursor(0, 1);
                      // print the number of seconds since reset:
                      lcd.print("Time ");
                      lcd.print(bcd2bin( rtc.h24.Hour10, rtc.h24.Hour));
                      lcd.print(":");
                      lcd.print(bcd2bin( rtc.Minutes10, rtc.Minutes));
                      lcd.print(":");
                      lcd.print(bcd2bin( rtc.Seconds10, rtc.Seconds));
                      lcd.print("      ");
                      
                      cpmhour = bcd2bin( rtc.h24.Hour10, rtc.h24.Hour);
                      cpmmin  = bcd2bin( rtc.Minutes10, rtc.Minutes);
                      
  //                          Serial.print("Time = ");
  //                          Serial.print(cpmhour);
  //                          Serial.println(cpmmin); 
  
            }
            
            if (stringComplete) {
                //Serial.println(inputString);
                
                XPORT_Receive(inputString);
  
                // clear the string:
                inputString = "";
                stringComplete = false;
            }
            
            Check_Timer();

}

/*
  SerialEvent occurs whenever a new data comes in the
 hardware serial RX.  This routine is run between each
 time loop() runs, so using delay inside loop can delay
 response.  Multiple bytes of data may be available.
 */
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '\n') {
      stringComplete = true;
    }
  }
}

